





class Polynom extends Function implements Differentiable {

    private int[] coefficients;

    public Polynom(int[] _coefficients){
	coefficients = _coefficients.clone();
    }

    public int differentiate(int x){
	if(coefficients.length <= 1)
	    return 0;
	
	int r=0; 
	for(int i=0; i< coefficients.length - 1; i++)
	    r+=(coefficients.length - i - 1)*coefficients[i]*x;
	return r;
    }

    public String toString(){
	String str="";
	str +=  coefficients[0] + "x^" + (coefficients.length-1);
	for(int d=1; d<coefficients.length; d++){
	    str += " + " + coefficients[d] + "x^" + (coefficients.length-d-1) ;
	}
	return str;
    }

    public int compute(int x){
	int result=0;
	for(int i=0; i<coefficients.length; i++)
	    result+= coefficients[i] * (int)(Math.pow(x,coefficients.length-(i+1)));
	return result;
    }    

}
